/*
    $Id: bst.c,v 1.2 1999/07/11 00:26:02 james Exp $

    bst, Videopad Basestation Temperature Module
    Copyright (C) 1999  James Cameron  (quozl@us.netrek.org)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef lint
static char vcid[] = "$Id: bst.c,v 1.2 1999/07/11 00:26:02 james Exp $";
#endif /* lint */

/*
    Echoes data from one Videopad to the other if the data matches the
    format used by the temperature reporting protocol.
*/

#include <stdio.h>
#include <ctype.h>
#include <time.h>
#include <string.h>

#include "vpd.h"
#include "bst.h"

#define MAXMSG 2048

char response[MAXMSG];

int bst ( int rlun, const char *pdu, int length )
{
    char *token;
    char message[MAXMSG];
    static int listener = 0;
    
    memcpy ( message, pdu, length );
    message[length] = '\0';
    
    if ( message[0] != '|' ) return 0;
    if ( message[1] != '|' ) return 0;
    
    token = strtok ( message, "|" );
    if ( strcmp ( token, "temperature" ) ) return 0;
    
    token = strtok ( NULL, "|" );
    
    if ( ! strcmp ( token, "listen" ) )
    {
        listener = rlun;
        return 1;
    }
    
    if ( listener == 0 ) return 1;

    if ( ! strcmp ( token, "unlisten" ) )
    {
        if ( rlun == listener ) listener = 0;
        return 1;
    }
    
    if (
        ! strcmp ( token, "start" ) ||
        ! strcmp ( token, "data"  ) ||
        ! strcmp ( token, "stop"  )
    )
    {
        send_block ( listener, ( unsigned char * ) pdu, length );
        return 1;
    }
    
    return 0;
}
